r"""Wrapper for AIOUSB.h

Generated with:
./run.py AIOUSB.h -l AIOUSB -o AIOUSB.py

Do not modify this file.
"""

__docformat__ = "restructuredtext"

# Begin preamble for Python v(3, 2)

import ctypes, os, sys
from ctypes import *

_int_types = (c_int16, c_int32)
if hasattr(ctypes, "c_int64"):
    # Some builds of ctypes apparently do not have c_int64
    # defined; it's a pretty good bet that these builds do not
    # have 64-bit pointers.
    _int_types += (c_int64,)
for t in _int_types:
    if sizeof(t) == sizeof(c_size_t):
        c_ptrdiff_t = t
del t
del _int_types


class UserString:
    def __init__(self, seq):
        if isinstance(seq, bytes):
            self.data = seq
        elif isinstance(seq, UserString):
            self.data = seq.data[:]
        else:
            self.data = str(seq).encode()

    def __bytes__(self):
        return self.data

    def __str__(self):
        return self.data.decode()

    def __repr__(self):
        return repr(self.data)

    def __int__(self):
        return int(self.data.decode())

    def __long__(self):
        return int(self.data.decode())

    def __float__(self):
        return float(self.data.decode())

    def __complex__(self):
        return complex(self.data.decode())

    def __hash__(self):
        return hash(self.data)

    def __cmp__(self, string):
        if isinstance(string, UserString):
            return cmp(self.data, string.data)
        else:
            return cmp(self.data, string)

    def __le__(self, string):
        if isinstance(string, UserString):
            return self.data <= string.data
        else:
            return self.data <= string

    def __lt__(self, string):
        if isinstance(string, UserString):
            return self.data < string.data
        else:
            return self.data < string

    def __ge__(self, string):
        if isinstance(string, UserString):
            return self.data >= string.data
        else:
            return self.data >= string

    def __gt__(self, string):
        if isinstance(string, UserString):
            return self.data > string.data
        else:
            return self.data > string

    def __eq__(self, string):
        if isinstance(string, UserString):
            return self.data == string.data
        else:
            return self.data == string

    def __ne__(self, string):
        if isinstance(string, UserString):
            return self.data != string.data
        else:
            return self.data != string

    def __contains__(self, char):
        return char in self.data

    def __len__(self):
        return len(self.data)

    def __getitem__(self, index):
        return self.__class__(self.data[index])

    def __getslice__(self, start, end):
        start = max(start, 0)
        end = max(end, 0)
        return self.__class__(self.data[start:end])

    def __add__(self, other):
        if isinstance(other, UserString):
            return self.__class__(self.data + other.data)
        elif isinstance(other, bytes):
            return self.__class__(self.data + other)
        else:
            return self.__class__(self.data + str(other).encode())

    def __radd__(self, other):
        if isinstance(other, bytes):
            return self.__class__(other + self.data)
        else:
            return self.__class__(str(other).encode() + self.data)

    def __mul__(self, n):
        return self.__class__(self.data * n)

    __rmul__ = __mul__

    def __mod__(self, args):
        return self.__class__(self.data % args)

    # the following methods are defined in alphabetical order:
    def capitalize(self):
        return self.__class__(self.data.capitalize())

    def center(self, width, *args):
        return self.__class__(self.data.center(width, *args))

    def count(self, sub, start=0, end=sys.maxsize):
        return self.data.count(sub, start, end)

    def decode(self, encoding=None, errors=None):  # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.decode(encoding, errors))
            else:
                return self.__class__(self.data.decode(encoding))
        else:
            return self.__class__(self.data.decode())

    def encode(self, encoding=None, errors=None):  # XXX improve this?
        if encoding:
            if errors:
                return self.__class__(self.data.encode(encoding, errors))
            else:
                return self.__class__(self.data.encode(encoding))
        else:
            return self.__class__(self.data.encode())

    def endswith(self, suffix, start=0, end=sys.maxsize):
        return self.data.endswith(suffix, start, end)

    def expandtabs(self, tabsize=8):
        return self.__class__(self.data.expandtabs(tabsize))

    def find(self, sub, start=0, end=sys.maxsize):
        return self.data.find(sub, start, end)

    def index(self, sub, start=0, end=sys.maxsize):
        return self.data.index(sub, start, end)

    def isalpha(self):
        return self.data.isalpha()

    def isalnum(self):
        return self.data.isalnum()

    def isdecimal(self):
        return self.data.isdecimal()

    def isdigit(self):
        return self.data.isdigit()

    def islower(self):
        return self.data.islower()

    def isnumeric(self):
        return self.data.isnumeric()

    def isspace(self):
        return self.data.isspace()

    def istitle(self):
        return self.data.istitle()

    def isupper(self):
        return self.data.isupper()

    def join(self, seq):
        return self.data.join(seq)

    def ljust(self, width, *args):
        return self.__class__(self.data.ljust(width, *args))

    def lower(self):
        return self.__class__(self.data.lower())

    def lstrip(self, chars=None):
        return self.__class__(self.data.lstrip(chars))

    def partition(self, sep):
        return self.data.partition(sep)

    def replace(self, old, new, maxsplit=-1):
        return self.__class__(self.data.replace(old, new, maxsplit))

    def rfind(self, sub, start=0, end=sys.maxsize):
        return self.data.rfind(sub, start, end)

    def rindex(self, sub, start=0, end=sys.maxsize):
        return self.data.rindex(sub, start, end)

    def rjust(self, width, *args):
        return self.__class__(self.data.rjust(width, *args))

    def rpartition(self, sep):
        return self.data.rpartition(sep)

    def rstrip(self, chars=None):
        return self.__class__(self.data.rstrip(chars))

    def split(self, sep=None, maxsplit=-1):
        return self.data.split(sep, maxsplit)

    def rsplit(self, sep=None, maxsplit=-1):
        return self.data.rsplit(sep, maxsplit)

    def splitlines(self, keepends=0):
        return self.data.splitlines(keepends)

    def startswith(self, prefix, start=0, end=sys.maxsize):
        return self.data.startswith(prefix, start, end)

    def strip(self, chars=None):
        return self.__class__(self.data.strip(chars))

    def swapcase(self):
        return self.__class__(self.data.swapcase())

    def title(self):
        return self.__class__(self.data.title())

    def translate(self, *args):
        return self.__class__(self.data.translate(*args))

    def upper(self):
        return self.__class__(self.data.upper())

    def zfill(self, width):
        return self.__class__(self.data.zfill(width))


class MutableString(UserString):
    """mutable string objects

    Python strings are immutable objects.  This has the advantage, that
    strings may be used as dictionary keys.  If this property isn't needed
    and you insist on changing string values in place instead, you may cheat
    and use MutableString.

    But the purpose of this class is an educational one: to prevent
    people from inventing their own mutable string class derived
    from UserString and than forget thereby to remove (override) the
    __hash__ method inherited from UserString.  This would lead to
    errors that would be very hard to track down.

    A faster and better solution is to rewrite your program using lists."""

    def __init__(self, string=""):
        self.data = string

    def __hash__(self):
        raise TypeError("unhashable type (it is mutable)")

    def __setitem__(self, index, sub):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data):
            raise IndexError
        self.data = self.data[:index] + sub + self.data[index + 1 :]

    def __delitem__(self, index):
        if index < 0:
            index += len(self.data)
        if index < 0 or index >= len(self.data):
            raise IndexError
        self.data = self.data[:index] + self.data[index + 1 :]

    def __setslice__(self, start, end, sub):
        start = max(start, 0)
        end = max(end, 0)
        if isinstance(sub, UserString):
            self.data = self.data[:start] + sub.data + self.data[end:]
        elif isinstance(sub, bytes):
            self.data = self.data[:start] + sub + self.data[end:]
        else:
            self.data = self.data[:start] + str(sub).encode() + self.data[end:]

    def __delslice__(self, start, end):
        start = max(start, 0)
        end = max(end, 0)
        self.data = self.data[:start] + self.data[end:]

    def immutable(self):
        return UserString(self.data)

    def __iadd__(self, other):
        if isinstance(other, UserString):
            self.data += other.data
        elif isinstance(other, bytes):
            self.data += other
        else:
            self.data += str(other).encode()
        return self

    def __imul__(self, n):
        self.data *= n
        return self


class String(MutableString, Union):

    _fields_ = [("raw", POINTER(c_char)), ("data", c_char_p)]

    def __init__(self, obj=b""):
        if isinstance(obj, (bytes, UserString)):
            self.data = bytes(obj)
        else:
            self.raw = obj

    def __len__(self):
        return self.data and len(self.data) or 0

    def from_param(cls, obj):
        # Convert None or 0
        if obj is None or obj == 0:
            return cls(POINTER(c_char)())

        # Convert from String
        elif isinstance(obj, String):
            return obj

        # Convert from bytes
        elif isinstance(obj, bytes):
            return cls(obj)

        # Convert from str
        elif isinstance(obj, str):
            return cls(obj.encode())

        # Convert from c_char_p
        elif isinstance(obj, c_char_p):
            return obj

        # Convert from POINTER(c_char)
        elif isinstance(obj, POINTER(c_char)):
            return obj

        # Convert from raw pointer
        elif isinstance(obj, int):
            return cls(cast(obj, POINTER(c_char)))

        # Convert from c_char array
        elif isinstance(obj, c_char * len(obj)):
            return obj

        # Convert from object
        else:
            return String.from_param(obj._as_parameter_)

    from_param = classmethod(from_param)


def ReturnString(obj, func=None, arguments=None):
    return String.from_param(obj)


# As of ctypes 1.0, ctypes does not support custom error-checking
# functions on callbacks, nor does it support custom datatypes on
# callbacks, so we must ensure that all callbacks return
# primitive datatypes.
#
# Non-primitive return values wrapped with UNCHECKED won't be
# typechecked, and will be converted to c_void_p.
def UNCHECKED(type):
    if hasattr(type, "_type_") and isinstance(type._type_, str) and type._type_ != "P":
        return type
    else:
        return c_void_p


# ctypes doesn't have direct support for variadic functions, so we have to write
# our own wrapper class
class _variadic_function(object):
    def __init__(self, func, restype, argtypes, errcheck):
        self.func = func
        self.func.restype = restype
        self.argtypes = argtypes
        if errcheck:
            self.func.errcheck = errcheck

    def _as_parameter_(self):
        # So we can pass this variadic function as a function pointer
        return self.func

    def __call__(self, *args):
        fixed_args = []
        i = 0
        for argtype in self.argtypes:
            # Typecheck what we can
            fixed_args.append(argtype.from_param(args[i]))
            i += 1
        return self.func(*fixed_args + list(args[i:]))


def ord_if_char(value):
    """
    Simple helper used for casts to simple builtin types:  if the argument is a
    string type, it will be converted to it's ordinal value.

    This function will raise an exception if the argument is string with more
    than one characters.
    """
    return ord(value) if (isinstance(value, bytes) or isinstance(value, str)) else value

# End preamble

_libs = {}
_libdirs = []

# Begin loader

# ----------------------------------------------------------------------------
# Copyright (c) 2008 David James
# Copyright (c) 2006-2008 Alex Holkner
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#  * Neither the name of pyglet nor the names of its
#    contributors may be used to endorse or promote products
#    derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

import os.path, re, sys, glob
import platform
import ctypes
import ctypes.util


def _environ_path(name):
    if name in os.environ:
        return os.environ[name].split(":")
    else:
        return []


class LibraryLoader(object):
    # library names formatted specifically for platforms
    name_formats = ["%s"]

    class Lookup(object):
        mode = ctypes.DEFAULT_MODE

        def __init__(self, path):
            super(LibraryLoader.Lookup, self).__init__()
            self.access = dict(cdecl=ctypes.CDLL(path, self.mode))

        def get(self, name, calling_convention="cdecl"):
            if calling_convention not in self.access:
                raise LookupError(
                    "Unknown calling convention '{}' for function '{}'".format(
                        calling_convention, name
                    )
                )
            return getattr(self.access[calling_convention], name)

        def has(self, name, calling_convention="cdecl"):
            if calling_convention not in self.access:
                return False
            return hasattr(self.access[calling_convention], name)

        def __getattr__(self, name):
            return getattr(self.access["cdecl"], name)

    def __init__(self):
        self.other_dirs = []

    def __call__(self, libname):
        """Given the name of a library, load it."""
        paths = self.getpaths(libname)

        for path in paths:
            try:
                return self.Lookup(path)
            except:
                pass

        raise ImportError("Could not load %s." % libname)

    def getpaths(self, libname):
        """Return a list of paths where the library might be found."""
        if os.path.isabs(libname):
            yield libname
        else:
            # search through a prioritized series of locations for the library

            # we first search any specific directories identified by user
            for dir_i in self.other_dirs:
                for fmt in self.name_formats:
                    # dir_i should be absolute already
                    yield os.path.join(dir_i, fmt % libname)

            # then we search the directory where the generated python interface is stored
            for fmt in self.name_formats:
                yield os.path.abspath(os.path.join(os.path.dirname(__file__), fmt % libname))

            # now, use the ctypes tools to try to find the library
            for fmt in self.name_formats:
                path = ctypes.util.find_library(fmt % libname)
                if path:
                    yield path

            # then we search all paths identified as platform-specific lib paths
            for path in self.getplatformpaths(libname):
                yield path

            # Finally, we'll try the users current working directory
            for fmt in self.name_formats:
                yield os.path.abspath(os.path.join(os.path.curdir, fmt % libname))

    def getplatformpaths(self, libname):
        return []


# Darwin (Mac OS X)


class DarwinLibraryLoader(LibraryLoader):
    name_formats = [
        "lib%s.dylib",
        "lib%s.so",
        "lib%s.bundle",
        "%s.dylib",
        "%s.so",
        "%s.bundle",
        "%s",
    ]

    class Lookup(LibraryLoader.Lookup):
        # Darwin requires dlopen to be called with mode RTLD_GLOBAL instead
        # of the default RTLD_LOCAL.  Without this, you end up with
        # libraries not being loadable, resulting in "Symbol not found"
        # errors
        mode = ctypes.RTLD_GLOBAL

    def getplatformpaths(self, libname):
        if os.path.pathsep in libname:
            names = [libname]
        else:
            names = [format % libname for format in self.name_formats]

        for dir in self.getdirs(libname):
            for name in names:
                yield os.path.join(dir, name)

    def getdirs(self, libname):
        """Implements the dylib search as specified in Apple documentation:

        http://developer.apple.com/documentation/DeveloperTools/Conceptual/
            DynamicLibraries/Articles/DynamicLibraryUsageGuidelines.html

        Before commencing the standard search, the method first checks
        the bundle's ``Frameworks`` directory if the application is running
        within a bundle (OS X .app).
        """

        dyld_fallback_library_path = _environ_path("DYLD_FALLBACK_LIBRARY_PATH")
        if not dyld_fallback_library_path:
            dyld_fallback_library_path = [os.path.expanduser("~/lib"), "/usr/local/lib", "/usr/lib"]

        dirs = []

        if "/" in libname:
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))
        else:
            dirs.extend(_environ_path("LD_LIBRARY_PATH"))
            dirs.extend(_environ_path("DYLD_LIBRARY_PATH"))

        if hasattr(sys, "frozen") and sys.frozen == "macosx_app":
            dirs.append(os.path.join(os.environ["RESOURCEPATH"], "..", "Frameworks"))

        dirs.extend(dyld_fallback_library_path)

        return dirs


# Posix


class PosixLibraryLoader(LibraryLoader):
    _ld_so_cache = None

    _include = re.compile(r"^\s*include\s+(?P<pattern>.*)")

    class _Directories(dict):
        def __init__(self):
            self.order = 0

        def add(self, directory):
            if len(directory) > 1:
                directory = directory.rstrip(os.path.sep)
            # only adds and updates order if exists and not already in set
            if not os.path.exists(directory):
                return
            o = self.setdefault(directory, self.order)
            if o == self.order:
                self.order += 1

        def extend(self, directories):
            for d in directories:
                self.add(d)

        def ordered(self):
            return (i[0] for i in sorted(self.items(), key=lambda D: D[1]))

    def _get_ld_so_conf_dirs(self, conf, dirs):
        """
        Recursive funtion to help parse all ld.so.conf files, including proper
        handling of the `include` directive.
        """

        try:
            with open(conf) as f:
                for D in f:
                    D = D.strip()
                    if not D:
                        continue

                    m = self._include.match(D)
                    if not m:
                        dirs.add(D)
                    else:
                        for D2 in glob.glob(m.group("pattern")):
                            self._get_ld_so_conf_dirs(D2, dirs)
        except IOError:
            pass

    def _create_ld_so_cache(self):
        # Recreate search path followed by ld.so.  This is going to be
        # slow to build, and incorrect (ld.so uses ld.so.cache, which may
        # not be up-to-date).  Used only as fallback for distros without
        # /sbin/ldconfig.
        #
        # We assume the DT_RPATH and DT_RUNPATH binary sections are omitted.

        directories = self._Directories()
        for name in (
            "LD_LIBRARY_PATH",
            "SHLIB_PATH",  # HPUX
            "LIBPATH",  # OS/2, AIX
            "LIBRARY_PATH",  # BE/OS
        ):
            if name in os.environ:
                directories.extend(os.environ[name].split(os.pathsep))

        self._get_ld_so_conf_dirs("/etc/ld.so.conf", directories)

        bitage = platform.architecture()[0]

        unix_lib_dirs_list = []
        if bitage.startswith("64"):
            # prefer 64 bit if that is our arch
            unix_lib_dirs_list += ["/lib64", "/usr/lib64"]

        # must include standard libs, since those paths are also used by 64 bit
        # installs
        unix_lib_dirs_list += ["/lib", "/usr/lib"]
        if sys.platform.startswith("linux"):
            # Try and support multiarch work in Ubuntu
            # https://wiki.ubuntu.com/MultiarchSpec
            if bitage.startswith("32"):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ["/lib/i386-linux-gnu", "/usr/lib/i386-linux-gnu"]
            elif bitage.startswith("64"):
                # Assume Intel/AMD x86 compat
                unix_lib_dirs_list += ["/lib/x86_64-linux-gnu", "/usr/lib/x86_64-linux-gnu"]
            else:
                # guess...
                unix_lib_dirs_list += glob.glob("/lib/*linux-gnu")
        directories.extend(unix_lib_dirs_list)

        cache = {}
        lib_re = re.compile(r"lib(.*)\.s[ol]")
        ext_re = re.compile(r"\.s[ol]$")
        for dir in directories.ordered():
            try:
                for path in glob.glob("%s/*.s[ol]*" % dir):
                    file = os.path.basename(path)

                    # Index by filename
                    cache_i = cache.setdefault(file, set())
                    cache_i.add(path)

                    # Index by library name
                    match = lib_re.match(file)
                    if match:
                        library = match.group(1)
                        cache_i = cache.setdefault(library, set())
                        cache_i.add(path)
            except OSError:
                pass

        self._ld_so_cache = cache

    def getplatformpaths(self, libname):
        if self._ld_so_cache is None:
            self._create_ld_so_cache()

        result = self._ld_so_cache.get(libname, set())
        for i in result:
            # we iterate through all found paths for library, since we may have
            # actually found multiple architectures or other library types that
            # may not load
            yield i


# Windows


class WindowsLibraryLoader(LibraryLoader):
    name_formats = ["%s.dll", "lib%s.dll", "%slib.dll", "%s"]

    class Lookup(LibraryLoader.Lookup):
        def __init__(self, path):
            super(WindowsLibraryLoader.Lookup, self).__init__(path)
            self.access["stdcall"] = ctypes.windll.LoadLibrary(path)


# Platform switching

# If your value of sys.platform does not appear in this dict, please contact
# the Ctypesgen maintainers.

loaderclass = {
    "darwin": DarwinLibraryLoader,
    "cygwin": WindowsLibraryLoader,
    "win32": WindowsLibraryLoader,
    "msys": WindowsLibraryLoader,
}

load_library = loaderclass.get(sys.platform, PosixLibraryLoader)()


def add_library_search_dirs(other_dirs):
    """
    Add libraries to search paths.
    If library paths are relative, convert them to absolute with respect to this
    file's directory
    """
    for F in other_dirs:
        if not os.path.isabs(F):
            F = os.path.abspath(F)
        load_library.other_dirs.append(F)


del loaderclass

# End loader

add_library_search_dirs([])

# Begin libraries
_libs["AIOUSB"] = load_library("AIOUSB")

# 1 libraries
# End libraries

# No modules

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 26
for _lib in _libs.values():
    if not _lib.has("GetDevices", "cdecl"):
        continue
    GetDevices = _lib.get("GetDevices", "cdecl")
    GetDevices.argtypes = []
    GetDevices.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 27
for _lib in _libs.values():
    if not _lib.has("QueryDeviceInfo", "cdecl"):
        continue
    QueryDeviceInfo = _lib.get("QueryDeviceInfo", "cdecl")
    QueryDeviceInfo.argtypes = [c_uint32, POINTER(c_uint32), POINTER(c_uint32), String, POINTER(c_uint32), POINTER(c_uint32)]
    QueryDeviceInfo.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 28
for _lib in _libs.values():
    if not _lib.has("AIOUSB_CloseDevice", "cdecl"):
        continue
    AIOUSB_CloseDevice = _lib.get("AIOUSB_CloseDevice", "cdecl")
    AIOUSB_CloseDevice.argtypes = [c_uint32]
    AIOUSB_CloseDevice.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 29
for _lib in _libs.values():
    if not _lib.has("ClearDevices", "cdecl"):
        continue
    ClearDevices = _lib.get("ClearDevices", "cdecl")
    ClearDevices.argtypes = []
    ClearDevices.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 30
for _lib in _libs.values():
    if not _lib.has("GetDeviceUniqueStr", "cdecl"):
        continue
    GetDeviceUniqueStr = _lib.get("GetDeviceUniqueStr", "cdecl")
    GetDeviceUniqueStr.argtypes = [c_uint32, POINTER(c_uint32), String]
    GetDeviceUniqueStr.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 31
for _lib in _libs.values():
    if not _lib.has("GetDeviceSerialNumber", "cdecl"):
        continue
    GetDeviceSerialNumber = _lib.get("GetDeviceSerialNumber", "cdecl")
    GetDeviceSerialNumber.argtypes = [c_uint32, POINTER(c_int64)]
    GetDeviceSerialNumber.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 32
for _lib in _libs.values():
    if not _lib.has("ResolveDeviceIndex", "cdecl"):
        continue
    ResolveDeviceIndex = _lib.get("ResolveDeviceIndex", "cdecl")
    ResolveDeviceIndex.argtypes = [c_uint32]
    ResolveDeviceIndex.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 33
for _lib in _libs.values():
    if not _lib.has("GetDeviceByEEPROMByte", "cdecl"):
        continue
    GetDeviceByEEPROMByte = _lib.get("GetDeviceByEEPROMByte", "cdecl")
    GetDeviceByEEPROMByte.argtypes = [c_uint8]
    GetDeviceByEEPROMByte.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 34
for _lib in _libs.values():
    if not _lib.has("GetDeviceByEEPROMData", "cdecl"):
        continue
    GetDeviceByEEPROMData = _lib.get("GetDeviceByEEPROMData", "cdecl")
    GetDeviceByEEPROMData.argtypes = [c_uint32, c_uint32, POINTER(c_uint8)]
    GetDeviceByEEPROMData.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 35
for _lib in _libs.values():
    if not _lib.has("GetDeviceBySerialNumber", "cdecl"):
        continue
    GetDeviceBySerialNumber = _lib.get("GetDeviceBySerialNumber", "cdecl")
    GetDeviceBySerialNumber.argtypes = [POINTER(c_uint64)]
    GetDeviceBySerialNumber.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 36
for _lib in _libs.values():
    if not _lib.has("AIOUSB_ClearFIFO", "cdecl"):
        continue
    AIOUSB_ClearFIFO = _lib.get("AIOUSB_ClearFIFO", "cdecl")
    AIOUSB_ClearFIFO.argtypes = [c_uint32, c_uint32]
    AIOUSB_ClearFIFO.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 37
for _lib in _libs.values():
    if not _lib.has("AIOUSB_GetStreamStatus", "cdecl"):
        continue
    AIOUSB_GetStreamStatus = _lib.get("AIOUSB_GetStreamStatus", "cdecl")
    AIOUSB_GetStreamStatus.argtypes = [c_uint32, POINTER(c_uint32)]
    AIOUSB_GetStreamStatus.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 38
for _lib in _libs.values():
    if not _lib.has("AIOUSB_SetStreamingBlockSize", "cdecl"):
        continue
    AIOUSB_SetStreamingBlockSize = _lib.get("AIOUSB_SetStreamingBlockSize", "cdecl")
    AIOUSB_SetStreamingBlockSize.argtypes = [c_uint32, c_uint32]
    AIOUSB_SetStreamingBlockSize.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 39
for _lib in _libs.values():
    if not _lib.has("AIOUSB_ResetChip", "cdecl"):
        continue
    AIOUSB_ResetChip = _lib.get("AIOUSB_ResetChip", "cdecl")
    AIOUSB_ResetChip.argtypes = [c_uint32]
    AIOUSB_ResetChip.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 40
for _lib in _libs.values():
    if not _lib.has("AIOUSB_ReloadDeviceLinks", "cdecl"):
        continue
    AIOUSB_ReloadDeviceLinks = _lib.get("AIOUSB_ReloadDeviceLinks", "cdecl")
    AIOUSB_ReloadDeviceLinks.argtypes = []
    AIOUSB_ReloadDeviceLinks.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 41
for _lib in _libs.values():
    if not _lib.has("AIOUSB_UploadD15LoFirmwaresByPID", "cdecl"):
        continue
    AIOUSB_UploadD15LoFirmwaresByPID = _lib.get("AIOUSB_UploadD15LoFirmwaresByPID", "cdecl")
    AIOUSB_UploadD15LoFirmwaresByPID.argtypes = [String]
    AIOUSB_UploadD15LoFirmwaresByPID.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 42
for _lib in _libs.values():
    if not _lib.has("AIOUSB_QuerySimplePNPData", "cdecl"):
        continue
    AIOUSB_QuerySimplePNPData = _lib.get("AIOUSB_QuerySimplePNPData", "cdecl")
    AIOUSB_QuerySimplePNPData.argtypes = [c_uint32, POINTER(None), POINTER(c_uint32)]
    AIOUSB_QuerySimplePNPData.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 43
for _lib in _libs.values():
    if not _lib.has("CustomEEPROMRead", "cdecl"):
        continue
    CustomEEPROMRead = _lib.get("CustomEEPROMRead", "cdecl")
    CustomEEPROMRead.argtypes = [c_uint32, c_uint32, POINTER(c_uint32), POINTER(None)]
    CustomEEPROMRead.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 44
for _lib in _libs.values():
    if not _lib.has("CustomEEPROMWrite", "cdecl"):
        continue
    CustomEEPROMWrite = _lib.get("CustomEEPROMWrite", "cdecl")
    CustomEEPROMWrite.argtypes = [c_uint32, c_uint32, c_uint32, POINTER(None)]
    CustomEEPROMWrite.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 45
for _lib in _libs.values():
    if not _lib.has("AIOUSB_FlashRead", "cdecl"):
        continue
    AIOUSB_FlashRead = _lib.get("AIOUSB_FlashRead", "cdecl")
    AIOUSB_FlashRead.argtypes = [c_uint32, c_uint32, POINTER(c_uint32), POINTER(None)]
    AIOUSB_FlashRead.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 46
for _lib in _libs.values():
    if not _lib.has("AIOUSB_FlashWrite", "cdecl"):
        continue
    AIOUSB_FlashWrite = _lib.get("AIOUSB_FlashWrite", "cdecl")
    AIOUSB_FlashWrite.argtypes = [c_uint32, c_uint32, c_uint32, POINTER(None)]
    AIOUSB_FlashWrite.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 47
for _lib in _libs.values():
    if not _lib.has("AIOUSB_FlashEraseSector", "cdecl"):
        continue
    AIOUSB_FlashEraseSector = _lib.get("AIOUSB_FlashEraseSector", "cdecl")
    AIOUSB_FlashEraseSector.argtypes = [c_uint32, c_int32]
    AIOUSB_FlashEraseSector.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 48
for _lib in _libs.values():
    if not _lib.has("GenericVendorRead", "cdecl"):
        continue
    GenericVendorRead = _lib.get("GenericVendorRead", "cdecl")
    GenericVendorRead.argtypes = [c_uint32, c_uint8, c_uint16, c_uint16, POINTER(c_uint32), POINTER(None)]
    GenericVendorRead.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 49
for _lib in _libs.values():
    if not _lib.has("GenericVendorWrite", "cdecl"):
        continue
    GenericVendorWrite = _lib.get("GenericVendorWrite", "cdecl")
    GenericVendorWrite.argtypes = [c_uint32, c_uint8, c_uint16, c_uint16, c_uint32, POINTER(None)]
    GenericVendorWrite.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 50
for _lib in _libs.values():
    if not _lib.has("AWU_GenericBulkIn", "cdecl"):
        continue
    AWU_GenericBulkIn = _lib.get("AWU_GenericBulkIn", "cdecl")
    AWU_GenericBulkIn.argtypes = [c_uint32, c_uint32, POINTER(None), c_uint32, POINTER(c_uint32)]
    AWU_GenericBulkIn.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 51
for _lib in _libs.values():
    if not _lib.has("AWU_GenericBulkOut", "cdecl"):
        continue
    AWU_GenericBulkOut = _lib.get("AWU_GenericBulkOut", "cdecl")
    AWU_GenericBulkOut.argtypes = [c_uint32, c_uint32, POINTER(None), c_uint32, POINTER(c_uint32)]
    AWU_GenericBulkOut.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 52
for _lib in _libs.values():
    if not _lib.has("ADC_GetScan", "cdecl"):
        continue
    ADC_GetScan = _lib.get("ADC_GetScan", "cdecl")
    ADC_GetScan.argtypes = [c_uint32, POINTER(c_uint16)]
    ADC_GetScan.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 53
for _lib in _libs.values():
    if not _lib.has("ADC_GetScanV", "cdecl"):
        continue
    ADC_GetScanV = _lib.get("ADC_GetScanV", "cdecl")
    ADC_GetScanV.argtypes = [c_uint32, POINTER(c_double)]
    ADC_GetScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 54
for _lib in _libs.values():
    if not _lib.has("ADC_GetChannelV", "cdecl"):
        continue
    ADC_GetChannelV = _lib.get("ADC_GetChannelV", "cdecl")
    ADC_GetChannelV.argtypes = [c_uint32, c_uint32, POINTER(c_double)]
    ADC_GetChannelV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 55
for _lib in _libs.values():
    if not _lib.has("ADC_GetCalRefV", "cdecl"):
        continue
    ADC_GetCalRefV = _lib.get("ADC_GetCalRefV", "cdecl")
    ADC_GetCalRefV.argtypes = [c_uint32, c_uint32, POINTER(c_double)]
    ADC_GetCalRefV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 56
for _lib in _libs.values():
    if not _lib.has("ADC_GetTrigScan", "cdecl"):
        continue
    ADC_GetTrigScan = _lib.get("ADC_GetTrigScan", "cdecl")
    ADC_GetTrigScan.argtypes = [c_uint32, POINTER(c_uint16), c_long]
    ADC_GetTrigScan.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 57
for _lib in _libs.values():
    if not _lib.has("ADC_GetTrigScanV", "cdecl"):
        continue
    ADC_GetTrigScanV = _lib.get("ADC_GetTrigScanV", "cdecl")
    ADC_GetTrigScanV.argtypes = [c_uint32, POINTER(c_double), c_long]
    ADC_GetTrigScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 58
for _lib in _libs.values():
    if not _lib.has("ADC_GetConfig", "cdecl"):
        continue
    ADC_GetConfig = _lib.get("ADC_GetConfig", "cdecl")
    ADC_GetConfig.argtypes = [c_uint32, POINTER(None), POINTER(c_uint32)]
    ADC_GetConfig.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 59
for _lib in _libs.values():
    if not _lib.has("ADC_SetConfig", "cdecl"):
        continue
    ADC_SetConfig = _lib.get("ADC_SetConfig", "cdecl")
    ADC_SetConfig.argtypes = [c_uint32, POINTER(None), POINTER(c_uint32)]
    ADC_SetConfig.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 60
for _lib in _libs.values():
    if not _lib.has("ADC_ADMode", "cdecl"):
        continue
    ADC_ADMode = _lib.get("ADC_ADMode", "cdecl")
    ADC_ADMode.argtypes = [c_uint32, c_uint8, c_uint8]
    ADC_ADMode.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 61
for _lib in _libs.values():
    if not _lib.has("ADC_Range1", "cdecl"):
        continue
    ADC_Range1 = _lib.get("ADC_Range1", "cdecl")
    ADC_Range1.argtypes = [c_uint32, c_uint32, c_uint8, c_uint32]
    ADC_Range1.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 62
for _lib in _libs.values():
    if not _lib.has("ADC_RangeAll", "cdecl"):
        continue
    ADC_RangeAll = _lib.get("ADC_RangeAll", "cdecl")
    ADC_RangeAll.argtypes = [c_uint32, POINTER(c_uint8), c_uint32]
    ADC_RangeAll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 63
for _lib in _libs.values():
    if not _lib.has("ADC_SetScanLimits", "cdecl"):
        continue
    ADC_SetScanLimits = _lib.get("ADC_SetScanLimits", "cdecl")
    ADC_SetScanLimits.argtypes = [c_uint32, c_uint32, c_uint32]
    ADC_SetScanLimits.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 64
for _lib in _libs.values():
    if not _lib.has("ADC_SetOversample", "cdecl"):
        continue
    ADC_SetOversample = _lib.get("ADC_SetOversample", "cdecl")
    ADC_SetOversample.argtypes = [c_uint32, c_uint8]
    ADC_SetOversample.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 65
for _lib in _libs.values():
    if not _lib.has("ADC_QueryCal", "cdecl"):
        continue
    ADC_QueryCal = _lib.get("ADC_QueryCal", "cdecl")
    ADC_QueryCal.argtypes = [c_uint32]
    ADC_QueryCal.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 66
for _lib in _libs.values():
    if not _lib.has("ADC_SetCal", "cdecl"):
        continue
    ADC_SetCal = _lib.get("ADC_SetCal", "cdecl")
    ADC_SetCal.argtypes = [c_uint32, String]
    ADC_SetCal.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 67
for _lib in _libs.values():
    if not _lib.has("ADC_SetCalAndSave", "cdecl"):
        continue
    ADC_SetCalAndSave = _lib.get("ADC_SetCalAndSave", "cdecl")
    ADC_SetCalAndSave.argtypes = [c_uint32, String, String]
    ADC_SetCalAndSave.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 68
for _lib in _libs.values():
    if not _lib.has("ADC_Initialize", "cdecl"):
        continue
    ADC_Initialize = _lib.get("ADC_Initialize", "cdecl")
    ADC_Initialize.argtypes = [c_uint32, POINTER(None), POINTER(c_uint32), String]
    ADC_Initialize.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 69
for _lib in _libs.values():
    if not _lib.has("ADC_GetImmediate", "cdecl"):
        continue
    ADC_GetImmediate = _lib.get("ADC_GetImmediate", "cdecl")
    ADC_GetImmediate.argtypes = [c_uint32, c_uint32, POINTER(c_uint16)]
    ADC_GetImmediate.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 70
for _lib in _libs.values():
    if not _lib.has("ADC_BulkAcquire", "cdecl"):
        continue
    ADC_BulkAcquire = _lib.get("ADC_BulkAcquire", "cdecl")
    ADC_BulkAcquire.argtypes = [c_uint32, c_uint32, POINTER(None)]
    ADC_BulkAcquire.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 71
for _lib in _libs.values():
    if not _lib.has("ADC_BulkPoll", "cdecl"):
        continue
    ADC_BulkPoll = _lib.get("ADC_BulkPoll", "cdecl")
    ADC_BulkPoll.argtypes = [c_uint32, POINTER(c_uint32)]
    ADC_BulkPoll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 72
for _lib in _libs.values():
    if not _lib.has("ADC_BulkAbort", "cdecl"):
        continue
    ADC_BulkAbort = _lib.get("ADC_BulkAbort", "cdecl")
    ADC_BulkAbort.argtypes = [c_uint32]
    ADC_BulkAbort.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 73
for _lib in _libs.values():
    if not _lib.has("ADC_BulkMode", "cdecl"):
        continue
    ADC_BulkMode = _lib.get("ADC_BulkMode", "cdecl")
    ADC_BulkMode.argtypes = [c_uint32, c_uint32]
    ADC_BulkMode.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 74
for _lib in _libs.values():
    if not _lib.has("ADC_BulkContinuousCallbackStart", "cdecl"):
        continue
    ADC_BulkContinuousCallbackStart = _lib.get("ADC_BulkContinuousCallbackStart", "cdecl")
    ADC_BulkContinuousCallbackStart.argtypes = [c_uint32, c_uint32, c_uint32, c_uint32, POINTER(None)]
    ADC_BulkContinuousCallbackStart.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 75
for _lib in _libs.values():
    if not _lib.has("ADC_BulkContinuousCallbackStartClocked", "cdecl"):
        continue
    ADC_BulkContinuousCallbackStartClocked = _lib.get("ADC_BulkContinuousCallbackStartClocked", "cdecl")
    ADC_BulkContinuousCallbackStartClocked.argtypes = [c_uint32, c_uint32, c_uint32, c_uint32, POINTER(None), POINTER(c_double)]
    ADC_BulkContinuousCallbackStartClocked.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 76
for _lib in _libs.values():
    if not _lib.has("ADC_BulkContinuousRingStart", "cdecl"):
        continue
    ADC_BulkContinuousRingStart = _lib.get("ADC_BulkContinuousRingStart", "cdecl")
    ADC_BulkContinuousRingStart.argtypes = [c_uint32, c_uint32, c_uint32]
    ADC_BulkContinuousRingStart.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 77
for _lib in _libs.values():
    if not _lib.has("ADC_BulkContinuousEnd", "cdecl"):
        continue
    ADC_BulkContinuousEnd = _lib.get("ADC_BulkContinuousEnd", "cdecl")
    ADC_BulkContinuousEnd.argtypes = [c_uint32, POINTER(c_uint32)]
    ADC_BulkContinuousEnd.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 78
for _lib in _libs.values():
    if not _lib.has("ADC_FullStartRing", "cdecl"):
        continue
    ADC_FullStartRing = _lib.get("ADC_FullStartRing", "cdecl")
    ADC_FullStartRing.argtypes = [c_uint32, POINTER(None), POINTER(c_uint32), String, POINTER(c_double), c_uint32, c_uint32]
    ADC_FullStartRing.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 79
for _lib in _libs.values():
    if not _lib.has("ADC_ReadData", "cdecl"):
        continue
    ADC_ReadData = _lib.get("ADC_ReadData", "cdecl")
    ADC_ReadData.argtypes = [c_uint32, POINTER(None), POINTER(c_uint32), POINTER(c_double), c_double]
    ADC_ReadData.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 80
for _lib in _libs.values():
    if not _lib.has("ADC_InitFastITScanV", "cdecl"):
        continue
    ADC_InitFastITScanV = _lib.get("ADC_InitFastITScanV", "cdecl")
    ADC_InitFastITScanV.argtypes = [c_uint32]
    ADC_InitFastITScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 81
for _lib in _libs.values():
    if not _lib.has("ADC_ResetFastITScanV", "cdecl"):
        continue
    ADC_ResetFastITScanV = _lib.get("ADC_ResetFastITScanV", "cdecl")
    ADC_ResetFastITScanV.argtypes = [c_uint32]
    ADC_ResetFastITScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 82
for _lib in _libs.values():
    if not _lib.has("ADC_SetFastITScanVChannels", "cdecl"):
        continue
    ADC_SetFastITScanVChannels = _lib.get("ADC_SetFastITScanVChannels", "cdecl")
    ADC_SetFastITScanVChannels.argtypes = [c_uint32, c_uint32]
    ADC_SetFastITScanVChannels.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 83
for _lib in _libs.values():
    if not _lib.has("ADC_GetFastITScanV", "cdecl"):
        continue
    ADC_GetFastITScanV = _lib.get("ADC_GetFastITScanV", "cdecl")
    ADC_GetFastITScanV.argtypes = [c_uint32, POINTER(c_double)]
    ADC_GetFastITScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 84
for _lib in _libs.values():
    if not _lib.has("ADC_GetITScanV", "cdecl"):
        continue
    ADC_GetITScanV = _lib.get("ADC_GetITScanV", "cdecl")
    ADC_GetITScanV.argtypes = [c_uint32, POINTER(c_double)]
    ADC_GetITScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 85
for _lib in _libs.values():
    if not _lib.has("ADC_InitFastScanV", "cdecl"):
        continue
    ADC_InitFastScanV = _lib.get("ADC_InitFastScanV", "cdecl")
    ADC_InitFastScanV.argtypes = [c_uint32]
    ADC_InitFastScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 86
for _lib in _libs.values():
    if not _lib.has("ADC_ResetFastScanV", "cdecl"):
        continue
    ADC_ResetFastScanV = _lib.get("ADC_ResetFastScanV", "cdecl")
    ADC_ResetFastScanV.argtypes = [c_uint32]
    ADC_ResetFastScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 87
for _lib in _libs.values():
    if not _lib.has("ADC_GetFastScanV", "cdecl"):
        continue
    ADC_GetFastScanV = _lib.get("ADC_GetFastScanV", "cdecl")
    ADC_GetFastScanV.argtypes = [c_uint32, POINTER(c_double)]
    ADC_GetFastScanV.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 88
for _lib in _libs.values():
    if not _lib.has("CTR_8254Load", "cdecl"):
        continue
    CTR_8254Load = _lib.get("CTR_8254Load", "cdecl")
    CTR_8254Load.argtypes = [c_uint32, c_uint32, c_uint32, c_uint16]
    CTR_8254Load.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 89
for _lib in _libs.values():
    if not _lib.has("CTR_8254Mode", "cdecl"):
        continue
    CTR_8254Mode = _lib.get("CTR_8254Mode", "cdecl")
    CTR_8254Mode.argtypes = [c_uint32, c_uint32, c_uint32, c_uint32]
    CTR_8254Mode.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 90
for _lib in _libs.values():
    if not _lib.has("CTR_8254ModeLoad", "cdecl"):
        continue
    CTR_8254ModeLoad = _lib.get("CTR_8254ModeLoad", "cdecl")
    CTR_8254ModeLoad.argtypes = [c_uint32, c_uint32, c_uint32, c_uint32, c_uint16]
    CTR_8254ModeLoad.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 91
for _lib in _libs.values():
    if not _lib.has("CTR_8254Read", "cdecl"):
        continue
    CTR_8254Read = _lib.get("CTR_8254Read", "cdecl")
    CTR_8254Read.argtypes = [c_uint32, c_uint32, c_uint32, POINTER(c_uint16)]
    CTR_8254Read.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 92
for _lib in _libs.values():
    if not _lib.has("CTR_8254ReadStatus", "cdecl"):
        continue
    CTR_8254ReadStatus = _lib.get("CTR_8254ReadStatus", "cdecl")
    CTR_8254ReadStatus.argtypes = [c_uint32, c_uint32, c_uint32, POINTER(c_uint16), POINTER(c_uint8)]
    CTR_8254ReadStatus.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 93
for _lib in _libs.values():
    if not _lib.has("CTR_8254ReadModeLoad", "cdecl"):
        continue
    CTR_8254ReadModeLoad = _lib.get("CTR_8254ReadModeLoad", "cdecl")
    CTR_8254ReadModeLoad.argtypes = [c_uint32, c_uint32, c_uint32, c_uint32, c_uint16, POINTER(c_uint16)]
    CTR_8254ReadModeLoad.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 94
for _lib in _libs.values():
    if not _lib.has("CTR_StartOutputFreq", "cdecl"):
        continue
    CTR_StartOutputFreq = _lib.get("CTR_StartOutputFreq", "cdecl")
    CTR_StartOutputFreq.argtypes = [c_uint32, c_uint32, POINTER(c_double)]
    CTR_StartOutputFreq.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 95
for _lib in _libs.values():
    if not _lib.has("CTR_8254ReadAll", "cdecl"):
        continue
    CTR_8254ReadAll = _lib.get("CTR_8254ReadAll", "cdecl")
    CTR_8254ReadAll.argtypes = [c_uint32, POINTER(c_uint16)]
    CTR_8254ReadAll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 96
for _lib in _libs.values():
    if not _lib.has("CTR_8254SelectGate", "cdecl"):
        continue
    CTR_8254SelectGate = _lib.get("CTR_8254SelectGate", "cdecl")
    CTR_8254SelectGate.argtypes = [c_uint32, c_uint32]
    CTR_8254SelectGate.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 97
for _lib in _libs.values():
    if not _lib.has("CTR_8254ReadLatched", "cdecl"):
        continue
    CTR_8254ReadLatched = _lib.get("CTR_8254ReadLatched", "cdecl")
    CTR_8254ReadLatched.argtypes = [c_uint32, POINTER(c_uint16)]
    CTR_8254ReadLatched.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 98
for _lib in _libs.values():
    if not _lib.has("CTR_SetWaitGates", "cdecl"):
        continue
    CTR_SetWaitGates = _lib.get("CTR_SetWaitGates", "cdecl")
    CTR_SetWaitGates.argtypes = [c_uint32, c_uint8, c_uint8]
    CTR_SetWaitGates.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 99
for _lib in _libs.values():
    if not _lib.has("CTR_EndWaitGates", "cdecl"):
        continue
    CTR_EndWaitGates = _lib.get("CTR_EndWaitGates", "cdecl")
    CTR_EndWaitGates.argtypes = [c_uint32]
    CTR_EndWaitGates.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 100
for _lib in _libs.values():
    if not _lib.has("CTR_WaitForGate", "cdecl"):
        continue
    CTR_WaitForGate = _lib.get("CTR_WaitForGate", "cdecl")
    CTR_WaitForGate.argtypes = [c_uint32, c_uint8, POINTER(c_uint16)]
    CTR_WaitForGate.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 101
for _lib in _libs.values():
    if not _lib.has("CTR_StartMeasuringPulseWidth", "cdecl"):
        continue
    CTR_StartMeasuringPulseWidth = _lib.get("CTR_StartMeasuringPulseWidth", "cdecl")
    CTR_StartMeasuringPulseWidth.argtypes = [c_uint32]
    CTR_StartMeasuringPulseWidth.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 102
for _lib in _libs.values():
    if not _lib.has("CTR_StopMeasuringPulseWidth", "cdecl"):
        continue
    CTR_StopMeasuringPulseWidth = _lib.get("CTR_StopMeasuringPulseWidth", "cdecl")
    CTR_StopMeasuringPulseWidth.argtypes = [c_uint32]
    CTR_StopMeasuringPulseWidth.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 103
for _lib in _libs.values():
    if not _lib.has("CTR_GetPulseWidthMeasurement", "cdecl"):
        continue
    CTR_GetPulseWidthMeasurement = _lib.get("CTR_GetPulseWidthMeasurement", "cdecl")
    CTR_GetPulseWidthMeasurement.argtypes = [c_uint32, c_uint32, c_uint32, POINTER(c_uint16)]
    CTR_GetPulseWidthMeasurement.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 104
for _lib in _libs.values():
    if not _lib.has("DIO_Configure", "cdecl"):
        continue
    DIO_Configure = _lib.get("DIO_Configure", "cdecl")
    DIO_Configure.argtypes = [c_uint32, c_uint8, POINTER(None), POINTER(None)]
    DIO_Configure.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 105
for _lib in _libs.values():
    if not _lib.has("DIO_ConfigureEx", "cdecl"):
        continue
    DIO_ConfigureEx = _lib.get("DIO_ConfigureEx", "cdecl")
    DIO_ConfigureEx.argtypes = [c_uint32, POINTER(None), POINTER(None), POINTER(None)]
    DIO_ConfigureEx.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 106
for _lib in _libs.values():
    if not _lib.has("DIO_ConfigureMasked", "cdecl"):
        continue
    DIO_ConfigureMasked = _lib.get("DIO_ConfigureMasked", "cdecl")
    DIO_ConfigureMasked.argtypes = [c_uint32, POINTER(None), POINTER(None), POINTER(None), POINTER(None), POINTER(None), POINTER(None)]
    DIO_ConfigureMasked.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 107
for _lib in _libs.values():
    if not _lib.has("DIO_ConfigurationQuery", "cdecl"):
        continue
    DIO_ConfigurationQuery = _lib.get("DIO_ConfigurationQuery", "cdecl")
    DIO_ConfigurationQuery.argtypes = [c_uint32, POINTER(None), POINTER(None)]
    DIO_ConfigurationQuery.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 108
for _lib in _libs.values():
    if not _lib.has("DIO_Read1", "cdecl"):
        continue
    DIO_Read1 = _lib.get("DIO_Read1", "cdecl")
    DIO_Read1.argtypes = [c_uint32, c_uint32, POINTER(c_uint8)]
    DIO_Read1.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 109
for _lib in _libs.values():
    if not _lib.has("DIO_Read8", "cdecl"):
        continue
    DIO_Read8 = _lib.get("DIO_Read8", "cdecl")
    DIO_Read8.argtypes = [c_uint32, c_uint32, POINTER(c_uint8)]
    DIO_Read8.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 110
for _lib in _libs.values():
    if not _lib.has("DIO_ReadAll", "cdecl"):
        continue
    DIO_ReadAll = _lib.get("DIO_ReadAll", "cdecl")
    DIO_ReadAll.argtypes = [c_uint32, POINTER(None)]
    DIO_ReadAll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 111
for _lib in _libs.values():
    if not _lib.has("DIO_Write1", "cdecl"):
        continue
    DIO_Write1 = _lib.get("DIO_Write1", "cdecl")
    DIO_Write1.argtypes = [c_uint32, c_uint32, c_uint8]
    DIO_Write1.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 112
for _lib in _libs.values():
    if not _lib.has("DIO_Write8", "cdecl"):
        continue
    DIO_Write8 = _lib.get("DIO_Write8", "cdecl")
    DIO_Write8.argtypes = [c_uint32, c_uint32, c_uint8]
    DIO_Write8.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 113
for _lib in _libs.values():
    if not _lib.has("DIO_WriteAll", "cdecl"):
        continue
    DIO_WriteAll = _lib.get("DIO_WriteAll", "cdecl")
    DIO_WriteAll.argtypes = [c_uint32, POINTER(None)]
    DIO_WriteAll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 114
for _lib in _libs.values():
    if not _lib.has("DIO_StreamOpen", "cdecl"):
        continue
    DIO_StreamOpen = _lib.get("DIO_StreamOpen", "cdecl")
    DIO_StreamOpen.argtypes = [c_uint32, c_uint32]
    DIO_StreamOpen.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 115
for _lib in _libs.values():
    if not _lib.has("DIO_StreamClose", "cdecl"):
        continue
    DIO_StreamClose = _lib.get("DIO_StreamClose", "cdecl")
    DIO_StreamClose.argtypes = [c_uint32]
    DIO_StreamClose.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 116
for _lib in _libs.values():
    if not _lib.has("DIO_StreamFrame", "cdecl"):
        continue
    DIO_StreamFrame = _lib.get("DIO_StreamFrame", "cdecl")
    DIO_StreamFrame.argtypes = [c_uint32, c_uint32, POINTER(c_uint16), POINTER(c_uint32)]
    DIO_StreamFrame.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 117
for _lib in _libs.values():
    if not _lib.has("DIO_StreamSetClocks", "cdecl"):
        continue
    DIO_StreamSetClocks = _lib.get("DIO_StreamSetClocks", "cdecl")
    DIO_StreamSetClocks.argtypes = [c_uint32, POINTER(c_double), POINTER(c_double)]
    DIO_StreamSetClocks.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 118
for _lib in _libs.values():
    if not _lib.has("DIO_SPI_Read", "cdecl"):
        continue
    DIO_SPI_Read = _lib.get("DIO_SPI_Read", "cdecl")
    DIO_SPI_Read.argtypes = [c_uint32, c_uint8, c_uint8, POINTER(c_uint8)]
    DIO_SPI_Read.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 119
for _lib in _libs.values():
    if not _lib.has("DIO_SPI_Write", "cdecl"):
        continue
    DIO_SPI_Write = _lib.get("DIO_SPI_Write", "cdecl")
    DIO_SPI_Write.argtypes = [c_uint32, c_uint8, c_uint8, c_uint8]
    DIO_SPI_Write.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 120
for _lib in _libs.values():
    if not _lib.has("DIO_CSA_DoSync", "cdecl"):
        continue
    DIO_CSA_DoSync = _lib.get("DIO_CSA_DoSync", "cdecl")
    DIO_CSA_DoSync.argtypes = [c_uint32, POINTER(c_double), POINTER(c_double), POINTER(c_double), POINTER(c_double)]
    DIO_CSA_DoSync.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 121
for _lib in _libs.values():
    if not _lib.has("DIO_CSA_DebounceSet", "cdecl"):
        continue
    DIO_CSA_DebounceSet = _lib.get("DIO_CSA_DebounceSet", "cdecl")
    DIO_CSA_DebounceSet.argtypes = [c_uint32, c_uint32]
    DIO_CSA_DebounceSet.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 122
for _lib in _libs.values():
    if not _lib.has("DIO_CSA_DebounceReadAll", "cdecl"):
        continue
    DIO_CSA_DebounceReadAll = _lib.get("DIO_CSA_DebounceReadAll", "cdecl")
    DIO_CSA_DebounceReadAll.argtypes = [c_uint32, POINTER(None)]
    DIO_CSA_DebounceReadAll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 123
for _lib in _libs.values():
    if not _lib.has("DAC_CSA_SetRangeLimits", "cdecl"):
        continue
    DAC_CSA_SetRangeLimits = _lib.get("DAC_CSA_SetRangeLimits", "cdecl")
    DAC_CSA_SetRangeLimits.argtypes = [c_uint32, POINTER(c_uint8)]
    DAC_CSA_SetRangeLimits.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 124
for _lib in _libs.values():
    if not _lib.has("DAC_CSA_ClearRangeLimits", "cdecl"):
        continue
    DAC_CSA_ClearRangeLimits = _lib.get("DAC_CSA_ClearRangeLimits", "cdecl")
    DAC_CSA_ClearRangeLimits.argtypes = [c_uint32]
    DAC_CSA_ClearRangeLimits.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 125
for _lib in _libs.values():
    if not _lib.has("DACDIO_WriteAll", "cdecl"):
        continue
    DACDIO_WriteAll = _lib.get("DACDIO_WriteAll", "cdecl")
    DACDIO_WriteAll.argtypes = [c_uint32, POINTER(c_uint16), POINTER(c_uint8)]
    DACDIO_WriteAll.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 126
for _lib in _libs.values():
    if not _lib.has("DACDirect", "cdecl"):
        continue
    DACDirect = _lib.get("DACDirect", "cdecl")
    DACDirect.argtypes = [c_uint32, c_uint32, c_uint16]
    DACDirect.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 127
for _lib in _libs.values():
    if not _lib.has("DACMultiDirect", "cdecl"):
        continue
    DACMultiDirect = _lib.get("DACMultiDirect", "cdecl")
    DACMultiDirect.argtypes = [c_uint32, POINTER(None), c_uint32]
    DACMultiDirect.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 128
for _lib in _libs.values():
    if not _lib.has("DACSetBoardRange", "cdecl"):
        continue
    DACSetBoardRange = _lib.get("DACSetBoardRange", "cdecl")
    DACSetBoardRange.argtypes = [c_uint32, c_uint32]
    DACSetBoardRange.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 129
for _lib in _libs.values():
    if not _lib.has("DACSetChannelCal", "cdecl"):
        continue
    DACSetChannelCal = _lib.get("DACSetChannelCal", "cdecl")
    DACSetChannelCal.argtypes = [c_uint32, c_uint32, String]
    DACSetChannelCal.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 130
for _lib in _libs.values():
    if not _lib.has("DACOutputProcess", "cdecl"):
        continue
    DACOutputProcess = _lib.get("DACOutputProcess", "cdecl")
    DACOutputProcess.argtypes = [c_uint32, POINTER(c_double), c_uint32, POINTER(c_uint16)]
    DACOutputProcess.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 131
for _lib in _libs.values():
    if not _lib.has("DACOutputOpen", "cdecl"):
        continue
    DACOutputOpen = _lib.get("DACOutputOpen", "cdecl")
    DACOutputOpen.argtypes = [c_uint32, POINTER(c_double)]
    DACOutputOpen.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 132
for _lib in _libs.values():
    if not _lib.has("DACOutputClose", "cdecl"):
        continue
    DACOutputClose = _lib.get("DACOutputClose", "cdecl")
    DACOutputClose.argtypes = [c_uint32, c_uint32]
    DACOutputClose.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 133
for _lib in _libs.values():
    if not _lib.has("DACOutputCloseNoEnd", "cdecl"):
        continue
    DACOutputCloseNoEnd = _lib.get("DACOutputCloseNoEnd", "cdecl")
    DACOutputCloseNoEnd.argtypes = [c_uint32, c_uint32]
    DACOutputCloseNoEnd.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 134
for _lib in _libs.values():
    if not _lib.has("DACOutputFrame", "cdecl"):
        continue
    DACOutputFrame = _lib.get("DACOutputFrame", "cdecl")
    DACOutputFrame.argtypes = [c_uint32, c_uint32, POINTER(c_uint16)]
    DACOutputFrame.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 135
for _lib in _libs.values():
    if not _lib.has("DACOutputFrameRaw", "cdecl"):
        continue
    DACOutputFrameRaw = _lib.get("DACOutputFrameRaw", "cdecl")
    DACOutputFrameRaw.argtypes = [c_uint32, c_uint32, POINTER(c_uint16)]
    DACOutputFrameRaw.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 136
for _lib in _libs.values():
    if not _lib.has("DACOutputSetCount", "cdecl"):
        continue
    DACOutputSetCount = _lib.get("DACOutputSetCount", "cdecl")
    DACOutputSetCount.argtypes = [c_uint32, c_uint32]
    DACOutputSetCount.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 137
for _lib in _libs.values():
    if not _lib.has("DACOutputStart", "cdecl"):
        continue
    DACOutputStart = _lib.get("DACOutputStart", "cdecl")
    DACOutputStart.argtypes = [c_uint32]
    DACOutputStart.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 138
for _lib in _libs.values():
    if not _lib.has("DACOutputSetInterlock", "cdecl"):
        continue
    DACOutputSetInterlock = _lib.get("DACOutputSetInterlock", "cdecl")
    DACOutputSetInterlock.argtypes = [c_uint32, c_uint32]
    DACOutputSetInterlock.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 139
for _lib in _libs.values():
    if not _lib.has("DACOutputSetClock", "cdecl"):
        continue
    DACOutputSetClock = _lib.get("DACOutputSetClock", "cdecl")
    DACOutputSetClock.argtypes = [c_uint32, POINTER(c_double)]
    DACOutputSetClock.restype = c_uint32
    break

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 15
try:
    diNone = 4294967295
except:
    pass

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 16
try:
    diFirst = 4294967294
except:
    pass

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 17
try:
    diOnly = 4294967293
except:
    pass

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 19
try:
    TIME_METHOD_NOW = 0
except:
    pass

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 20
try:
    TIME_METHOD_WAIT_INPUT_ENABLE = 86
except:
    pass

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 21
try:
    TIME_METHOD_NOW_AND_ABORT = 5
except:
    pass

# /home/jhentges/dev/ctypesgen/AIOUSB.h: 22
try:
    TIME_METHOD_WHEN_INPUT_ENABLE = 1
except:
    pass

# No inserted files

# No prefix-stripping